#pragma once
/*!*********************************************
* @file
* @brief Declarations of the member functions of the FitSqr class.
*/

#include "config.h"

/*
* $Header: https://svn.mpia.de/gulli/geirs/src/trunk/extern/fits2fwhm/FitSqr.h 798 2021-06-15 13:53:57Z mathar $
*/

/*!******************************************
* @brief FitSqr fits an curve of (x,y) pairs to a polynomial or rational polynomial form.
*/
class FitSqr {
public:
	FitSqr() ;

	static double det33(const double matr[3][3]) ;

	static void solve33(const double A[3][3], const double rhs[3], double res[3]) ;
	static void solve22(const double A[2][2], const double rhs[2], double res[2]) ;

	static void invert33(const double A[3][3], double inv[3][3]) ;

	static double sqrVar(const double x[], const double y[], int N, double alpha[3], int p) ;

	static double fitsqr(const double x[], const double y[], int N, double alpha[3], double alphaVar[3]) ;
	static double fitlin(const double x[], const double y[], int N, double alpha[2]) ;
	static double fitlin(const double x[], const double y[], int N, double alpha[2], int aducut) ;
#ifdef HAVE_GSL_GSL_LINALG_H
	static double fitpoly(const double x[], const double y[], int N, int deg, double alpha[]) ;
#endif

	static double fitsat(const double x[], const double y[], int N, double alpha[3]) ;
protected:
private:
} ;
